/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */
package j3d;
import java.awt.*;
import java.awt.font.*;
import java.awt.image.*;
import java.awt.geom.*;
/**
 * Insert the type's description here.
 *
 * @author: Yuriy Mikhaylovskiy
 */

public class shpOrientedText extends Rectangle2D.Double  implements shp{
  private float sx,sy,sz,x,y,z;
  private String text;
  private Color color;
  private boolean show = true;
  
  public void paint(Graphics2D g, Canvas3D j3d){
    if (!j3d.DRAFTMODE) {
      TextLayout tx = new TextLayout(text, g.getFont(), g.getFontRenderContext());
      g.setColor(color);
      tx.draw(g,x,y);
    }
  }

  public shpOrientedText(String st, float x, float y, float z){
    text=st;
    sx=x;
    sy=y;
    sz=z;
    color=Color.black;
  }
  public shpOrientedText(String st, float x, float y, float z, Color cl){
    text=st;
    sx=x;
    sy=y;
    sz=z;
    color=cl;
  }
  public void transform2D(Matrix3D t, Vector3D cor){
    sx += cor.x;
    sy += cor.y;
    sz += cor.z;
      
    x=sx*t.xx+sy*t.xy+sz*t.xz+t.xo;
    y=sx*t.yx+sy*t.yy+sz*t.yz+t.yo;
    z=sx*t.zx+sy*t.zy+sz*t.zz+t.zo;
    this.width=0;
    this.height=0;
    
    sx -= cor.x;
    sy -= cor.y;
    sz -= cor.z;
  }

  public float get_Z(){
    return z;
  }
  
  public boolean isPickPoint(int x, int y) {
      
      return false;
      
  }

  public boolean isPickPoint(Rectangle2D r) {
      
      return false;
      
  }
  public void setShow(boolean s) {
      show = s;
  }

  public boolean isShow() {
      return show;
  }
  
}